# -*- coding: utf-8 -*-
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
This module is used by portal_quickinstaller to install product
"""

__docformat__ = 'restructuredtext'

# Python imports
from StringIO import StringIO

# CMF
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions

# Archetypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.Archetypes.public import listTypes

# Products import
from Products.PloneQuiz.config import PROJECTNAME, GLOBALS


def install(self):
    """Install PloneQuiz product"""
    
    out = StringIO()

    # Install types
    typeInfo = listTypes(PROJECTNAME)
    installTypes(self, out,
                 typeInfo,
                 PROJECTNAME)

    # Install skin
    install_subskin(self, out, GLOBALS)

    # Use portal_factory to create temporary content
    ftool = getToolByName(self, 'portal_factory')
    ftool.manage_setPortalFactoryTypes(listOfTypeIds=('Quiz', 'QuizQA'))

    # no wf chain for question and folder workflow for quiz
    wtool = getToolByName(self, 'portal_workflow')
    wtool.setChainForPortalTypes(('Quiz',), 'folder_workflow')
    wtool.setChainForPortalTypes(('QuizQA',), '')
    
    out.write('Installation completed.\n')
    return out.getvalue()

def uninstall(self):
    """Uninstall PloneQuiz product"""
    
    out = StringIO()
    out.write('Uninstallation completed.\n')
    return out.getvalue()