# -*- coding: utf-8 -*-
## A Plone product to generate quiz. A quiz is a list of questions with the appropriate answer(s).
## Content managers can build quiz easily and present users a report about the errors they did.
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
Initialize PloneQuiz product
"""

__docformat__ = 'restructuredtext'

# CMF imports
from Products.CMFCore import DirectoryView, utils

# Archetypes imports
from Products.Archetypes.public import process_types, listTypes

# Products imports
from Products.PloneQuiz.config import GLOBALS, PROJECTNAME
from Products.PloneQuiz.permissions import AddQuiz
from Products.PloneQuiz import content

# Register skin directories so they can be added to portal_skins
DirectoryView.registerDirectory('skins', GLOBALS)

def initialize(context):
    # initialize the content, including types and add permissions
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = AddQuiz,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)