# -*- coding: utf-8 -*-
## A Plone product to generate quiz. A quiz is a list of questions with the appropriate answer(s).
## Content managers can build quiz easily and present users a report about the errors they did.
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
Defines all specific widgets used on a quiz
"""

# Python imports
from types import DictType

# Zope imports
from AccessControl import ClassSecurityInfo

# Archetypes imports
from Products.Archetypes.Widget import TypesWidget
from Products.Archetypes.Registry import registerWidget

class AnswerWidget(TypesWidget):
    __implements__ = TypesWidget.__implements__
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'macro' : "plonequiz_answer_widget",
        'helper_js': ('plonequiz_answer_widget.js',), 
        })
    security = ClassSecurityInfo()
    
    security.declarePublic('process_form')
    def process_form(self, instance, field, form, empty_marker=(),
                     emptyReturnsMarker=False):
        """ ... """
        
        value = form.get(field.getName(), empty_marker)
        if value is empty_marker: return empty_marker
        # Value is a list of tuple not a list of dictionary
        new_value = []
        for item in value:
            if not item:
                continue
            answer = item['answer']
            if not answer:
                continue
            
            checked = item.get('checked', False)
            new_value.append((answer, checked,))
        new_value = tuple(new_value)
        return new_value, {}

registerWidget(
    AnswerWidget,
    title='Answer grid',
    description=('A data grid, to enter all possible answers'),
    used_for=('Products.PloneQuiz.field.AnswerField',)
    )